diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
index 7d495c082..25b6198b7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentHotbar.java
@@ -20,8 +20,7 @@ import net.minecraft.core.util.helper.LightIndexHelper;
 
 import static net.minecraft.client.Minecraft.HOTBAR_SWAP_ANIMATION_LENGTH_TICKS;
 
-public class HudComponentHotbar
-    extends HudComponentMovable {
+public class HudComponentHotbar extends HudComponentMovable {
     private static final ItemStack[] PREVIEW_ITEMS = new ItemStack[]{
         new ItemStack(Blocks.STONE),
         new ItemStack(Blocks.COBBLE_STONE),
@@ -38,17 +37,57 @@ public class HudComponentHotbar
         super(key, 187, 22, layout);
     }
 
+    private boolean isVertical() {
+        return GameSettings.VERTICAL_HOT_BAR.value;
+    }
+
+    @Override
+    public int getDisplayedXSize() {
+        return this.isVertical() ? super.getDisplayedYSize() : super.getDisplayedXSize();
+    }
+
+    @Override
+    public int getDisplayedYSize() {
+        return this.isVertical() ? super.getDisplayedXSize() : super.getDisplayedYSize();
+    }
+
+    @Override
+    public int getTrueXSize() {
+        return this.isVertical() ? super.getTrueYSize() : super.getTrueXSize();
+    }
+
     @Override
-    public int getAnchorX(ComponentAnchor anchor) {
-        int xAnchor = super.getAnchorX(anchor);
-        if (anchor.xPosition == 0.0f) {
-            xAnchor += 5;
-        } else if (anchor.xPosition == 0.5f) {
-            xAnchor += 2;
+    public int getTrueYSize() {
+        return this.isVertical() ? super.getTrueXSize() : super.getTrueYSize();
+    }
+
+    // Offset anchors to account for the selector dots depending on orientation
+    @Override
+    public int getDisplayedAnchorX(ComponentAnchor anchor) {
+        int xAnchor = super.getDisplayedAnchorX(anchor);
+        if (!this.isVertical()) {
+            if (anchor.xPosition == 0.0f) {
+                xAnchor += 5;
+            } else if (anchor.xPosition == 0.5f) {
+                xAnchor += 2;
+            }
         }
         return xAnchor;
     }
 
+    @Override
+    public int getDisplayedAnchorY(ComponentAnchor anchor) {
+        int yAnchor = super.getDisplayedAnchorY(anchor);
+        if (this.isVertical()) {
+            if (anchor.yPosition == 0.0f) {
+                yAnchor += 5;
+            } else if (anchor.yPosition == 0.5f) {
+                yAnchor += 2;
+            }
+        }
+        return yAnchor;
+    }
+
     @Override
     public boolean isVisible() {
         return GameSettings.IMMERSIVE_MODE.drawHotbar();
@@ -60,125 +99,127 @@ public class HudComponentHotbar
         int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         ContainerInventory inv = mc.thePlayer.inventory;
+        boolean isVertical = this.isVertical();
 
-        // Setup hotbar texture
-        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-
-        // Render hotbar
-        hud.drawGuiIcon(x + 5, y, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
-
-        // Render hotbar switcher and dots
+        // Render background textures
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
         int selectedHotbar = ((inv.getHotbarOffset() + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE)) % ContainerInventory.MAIN_INVENTORY_SIZE) / ContainerInventory.HOTBAR_SIZE;
-        IconCoordinate coordinate = TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selector" + selectedHotbar);
-        hud.drawGuiIcon(x, y, 6, 22, coordinate);
+        boolean isLocked = mc.thePlayer.getHeldObject() != null;
+
+        drawOrientedBackgrounds(hud, x, y, selectedHotbar, inv.getCurrentSlot() % ContainerInventory.HOTBAR_SIZE, isLocked, isVertical);
 
         // Setup items
         GLRenderer.enableState(State.DEPTH_TEST);
         GLRenderer.enableState(State.BLEND);
         Lighting.enableInventoryLight();
+
         int lastHotbarStart = (mc.thePlayer.inventory.getHotbarOffset() + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE)) % ContainerInventory.MAIN_INVENTORY_SIZE;
         int nextHotbarStart = (mc.thePlayer.inventory.getHotbarOffset() + ContainerInventory.HOTBAR_SIZE) % ContainerInventory.MAIN_INVENTORY_SIZE;
 
         // Render hotbars being switched if appropriate
         if (mc.hotbarSwapAnimationProgress != 0.0f) {
-            Scissor.enable(x + 8, y + 3, 176, 16);
 
-            if (mc.hotbarSwapAnimationProgress > 0) {
+            // Adjust the scissor box based on orientation
+            if (isVertical) {
+                Scissor.enable(x + 3, y + 8, 16, 176);
+            } else {
+                Scissor.enable(x + 8, y + 3, 176, 16);
+            }
+
+            int animOffsetPrev = (int) (22 * (mc.hotbarSwapAnimationProgress - partialTick) / HOTBAR_SWAP_ANIMATION_LENGTH_TICKS);
+            int animOffsetNext = (int) (22 * (mc.hotbarSwapAnimationProgress + partialTick) / HOTBAR_SWAP_ANIMATION_LENGTH_TICKS);
 
+            if (mc.hotbarSwapAnimationProgress > 0) {
                 // Draw last hotbar
                 for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
-                    int itemX = x + 8 + itemIndex * 20;
-                    int itemY = y + 3 - 22 + (int) (22 * (mc.hotbarSwapAnimationProgress - partialTick) / HOTBAR_SWAP_ANIMATION_LENGTH_TICKS);
+                    int itemX = isVertical ? (x + 3 - 22 + animOffsetPrev) : (x + 8 + itemIndex * 20);
+                    int itemY = isVertical ? (y + 8 + itemIndex * 20) : (y + 3 - 22 + animOffsetPrev);
                     renderInventorySlot(mc, itemIndex + lastHotbarStart, itemX, itemY, partialTick);
                 }
 
-                // Render hotbar items
-                GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+                // Render current hotbar items
+                GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
                 for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
-                    int itemX = x + 8 + itemIndex * 20;
-                    int itemY = y + 3 + (int) (22 * (mc.hotbarSwapAnimationProgress - partialTick) / HOTBAR_SWAP_ANIMATION_LENGTH_TICKS);
+                    int itemX = isVertical ? (x + 3 + animOffsetPrev) : (x + 8 + itemIndex * 20);
+                    int itemY = isVertical ? (y + 8 + itemIndex * 20) : (y + 3 + animOffsetPrev);
                     renderInventorySlot(mc, itemIndex + mc.thePlayer.inventory.getHotbarOffset(), itemX, itemY, partialTick);
                 }
             } else {
                 // Draw next hotbar
                 for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
-                    int itemX = x + 8 + itemIndex * 20;
-                    int itemY = y + 3 + 22 + (int) (22 * (mc.hotbarSwapAnimationProgress + partialTick) / HOTBAR_SWAP_ANIMATION_LENGTH_TICKS);
+                    int itemX = isVertical ? (x + 3 + 22 + animOffsetNext) : (x + 8 + itemIndex * 20);
+                    int itemY = isVertical ? (y + 8 + itemIndex * 20) : (y + 3 + 22 + animOffsetNext);
                     renderInventorySlot(mc, itemIndex + nextHotbarStart, itemX, itemY, partialTick);
                 }
 
-                // Render hotbar items
-                GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+                // Render current hotbar items
+                GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
                 for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
-                    int itemX = x + 8 + itemIndex * 20;
-                    int itemY = y + 3 + (int) (22 * (mc.hotbarSwapAnimationProgress + partialTick) / HOTBAR_SWAP_ANIMATION_LENGTH_TICKS);
+                    int itemX = isVertical ? (x + 3 + animOffsetNext) : (x + 8 + itemIndex * 20);
+                    int itemY = isVertical ? (y + 8 + itemIndex * 20) : (y + 3 + animOffsetNext);
                     renderInventorySlot(mc, itemIndex + mc.thePlayer.inventory.getHotbarOffset(), itemX, itemY, partialTick);
                 }
             }
-
-
         } else {
-            // Render hotbar items
-            GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+            // Render static hotbar items
+            GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
             for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
-                int itemX = x + 8 + itemIndex * 20;
-                int itemY = y + 3;
+                int itemX = isVertical ? (x + 3) : (x + 8 + itemIndex * 20);
+                int itemY = isVertical ? (y + 8 + itemIndex * 20) : (y + 3);
                 renderInventorySlot(mc, itemIndex + mc.thePlayer.inventory.getHotbarOffset(), itemX, itemY, partialTick);
             }
         }
 
-
         Scissor.disable();
         Lighting.disable();
-
-        // Setup hotbar texture
-        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-
-        // Render selector
-        hud.drawGuiIcon((x + 4) + (inv.getCurrentSlot() % ContainerInventory.HOTBAR_SIZE) * 20, y - 1, 24, 24, TextureRegistry.getTexture(mc.thePlayer.getHeldObject() == null ? "minecraft:gui/hud/hotbar_selection" : "minecraft:gui/hud/hotbar_selection_locked"));
-
-        GLRenderer.pushFrame();
-        GLRenderer.modelM4f().translate(0, 0, 1f);
-        hud.heldItemTooltipElement.updateAndRender(mc, x + 5 + 182 / 2, y - 29);
-        GLRenderer.popFrame();
     }
 
     @Override
     public void renderPreview(Gui gui, Layout layout, int xSizeScreen, int ySizeScreen) {
         int x = layout.getComponentX(this, xSizeScreen);
         int y = layout.getComponentY(this, ySizeScreen);
+        boolean isVertical = this.isVertical();
 
-        // Setup hotbar texture
-        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
-
-        // Render hotbar
-        gui.drawGuiIcon(x + 5, y, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
-
-        // Render hotbar switcher and dots
-        final int selectedHotbar = 3;
-        IconCoordinate coordinate = TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selector" + selectedHotbar);
-        gui.drawGuiIcon(x, y, 6, 22, coordinate);
-
-        // Render selector
-        gui.drawGuiIcon((x + 4), y - 1, 24, 24, TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selection"));
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
 
+        // Draw backgrounds
+        drawOrientedBackgrounds(gui, x, y, 3, 0, false, isVertical);
 
         // Setup items
         GLRenderer.enableState(State.DEPTH_TEST);
         GLRenderer.enableState(State.BLEND);
         Lighting.enableInventoryLight();
 
-        // Render hotbar items
-        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f); // Reset color
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
         for (int itemIndex = 0; itemIndex < ContainerInventory.HOTBAR_SIZE; itemIndex++) {
-            int itemX = x + 8 + itemIndex * 20;
-            int itemY = y + 3;
+            int itemX = isVertical ? (x + 3) : (x + 8 + itemIndex * 20);
+            int itemY = isVertical ? (y + 8 + itemIndex * 20) : (y + 3);
             renderItem(mc, PREVIEW_ITEMS[itemIndex], itemX, itemY);
         }
 
         Lighting.disable();
     }
 
+    private void drawOrientedBackgrounds(Gui gui, int x, int y, int selectedHotbar, int currentSlotIndex, boolean isLocked, boolean isVertical) {
+        IconCoordinate selectorDots = TextureRegistry.getTexture("minecraft:gui/hud/hotbar_selector" + selectedHotbar);
+        String selTexture = "minecraft:gui/hud/hotbar_selection" + (isLocked ? "_locked" : "");
+
+        //Uses OpenGL matrix rotation to draw the horizontal hotbar vertically
+        if (isVertical) {
+            GLRenderer.pushFrame();
+            GLRenderer.modelM4f().translate(x + 22, y, 0);
+            GLRenderer.modelM4f().rotate((float) Math.toRadians(90), 0.0f, 0.0f, 1.0f);
+            gui.drawGuiIcon(5, 0, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
+            gui.drawGuiIcon(0, 0, 6, 22, selectorDots);
+            gui.drawGuiIcon(4 + currentSlotIndex * 20, -1, 24, 24, TextureRegistry.getTexture(selTexture));
+            GLRenderer.popFrame();
+        } else {
+            gui.drawGuiIcon(x + 5, y, 182, 22, TextureRegistry.getTexture("minecraft:gui/hud/hotbar"));
+            gui.drawGuiIcon(x, y, 6, 22, selectorDots);
+            gui.drawGuiIcon((x + 4) + currentSlotIndex * 20, y - 1, 24, 24, TextureRegistry.getTexture(selTexture));
+        }
+    }
+
     private void renderInventorySlot(Minecraft mc, int itemIndex, int x, int y, float partialTick) {
         ItemStack itemstack = mc.thePlayer.inventory.mainInventory[itemIndex];
         if (itemstack == null) {
@@ -193,7 +234,6 @@ public class HudComponentHotbar
             GLRenderer.modelM4f().scale(1.0F / f2, (f2 + 1.0F) / 2.0F, 1.0F);
             GLRenderer.modelM4f().translate(-(x + 8), -(y + 12), 0.0F);
         }
-//        itemModel.renderItemIntoGui(GLRenderer.getTessellator(), mc.font, mc.textureManager, itemstack, x, y, 1.0f);
         itemModel.renderGui(GLRenderer.getTessellator(), null, itemstack, x, y, LightIndexHelper.lightIndex2i(15, 15), partialTick);
         if (animProgress > 0.0F) {
             GLRenderer.popFrame();
@@ -203,8 +243,7 @@ public class HudComponentHotbar
 
     private void renderItem(Minecraft mc, ItemStack itemStack, int x, int y) {
         ItemModel itemModel = ItemModelDispatcher.getInstance().getDispatch(itemStack.getItem());
-//        itemModel.renderItemIntoGui(GLRenderer.getTessellator(), mc.font, mc.textureManager, itemStack, x, y, 1.0f);
         itemModel.renderGui(GLRenderer.getTessellator(), null, itemStack, x, y, LightIndexHelper.lightIndex2i(15, 15), 1f);
         itemModel.renderItemOverlayIntoGUI(GLRenderer.getTessellator(), mc.font, mc.textureManager, itemStack, x, y, null, 1.0f);
     }
-}
+}
\ No newline at end of file
